searchNodes=[{"type":"module","title":"AshAdmin.Api","doc":"An API extension to alter the behavior of an API in the admin UI. Table of Contents: admin DSL Docs: admin Configure the admin dashboard for a given API. :name ( String.t/0 ) - The name of the API in the dashboard. Will be derived if not set. :show? ( boolean/0 ) - Whether or not this API and its resources should be included in the admin dashboard. The default value is false . :default_resource_page - Set the default page for the resource to be the primary read action or the resource schema. Schema is the default for backwards compatibility, if a resource doesn't have a primary read action it will fallback to the schema view. Valid values are :schema, :primary_read The default value is :schema . :resource_group_labels ( keyword/0 ) - Humanized names for each resource group to appear in the admin area. These will be used as labels in the top navigation dropdown. If a key for a group does not appear in this mapping, the label will not be rendered. The default value is [] .","ref":"AshAdmin.Api.html"},{"type":"function","title":"AshAdmin.Api.default_resource_page/1","doc":"","ref":"AshAdmin.Api.html#default_resource_page/1"},{"type":"function","title":"AshAdmin.Api.name/1","doc":"","ref":"AshAdmin.Api.html#name/1"},{"type":"function","title":"AshAdmin.Api.resource_group_labels/1","doc":"","ref":"AshAdmin.Api.html#resource_group_labels/1"},{"type":"function","title":"AshAdmin.Api.show?/1","doc":"","ref":"AshAdmin.Api.html#show?/1"},{"type":"module","title":"AshAdmin.Resource","doc":"An API extension to alter the behaviour of a resource in the admin UI. Table of Contents: admin form field DSL Docs: admin Configure the admin dashboard for a given resource. form field :name ( String.t/0 ) - The proper name to use when this resource appears in the admin interface. :actor? ( boolean/0 ) - Whether or not this resource can be used as the actor for requests. :show_action ( atom/0 ) - The action to use when linking to the resource/viewing a single record. Defaults to the primary read action. :read_actions (list of atom/0 ) - A list of read actions that can be used to show resource details. By default, all actions are included. :create_actions (list of atom/0 ) - A list of create actions that can create records. By default, all actions are included. :update_actions (list of atom/0 ) - A list of update actions that can be used to update records. By default, all actions are included. :destroy_actions (list of atom/0 ) - A list of destroy actions that can be used to destroy records. By default, all actions are included. :polymorphic_tables (list of String.t/0 ) - For resources that use ash_postgres' polymorphism capabilities, you can provide a list of tables that should be available to select. These will be added to the list of derivable tables based on scanning all APIs and resources provided to ash_admin. :polymorphic_actions (list of atom/0 ) - For resources that use ash_postgres' polymorphism capabilities, you can provide a list of actions that should require a table to be set. If this is not set, then all actions will require tables. :table_columns (list of atom/0 ) - The list of attributes to render on the table view. :format_fields (list of term/0 ) - The list of fields and their formats. :relationship_display_fields (list of atom/0 ) - The list of attributes to render when it's shown as a relationship on a datatable :resource_group ( atom/0 ) - The group in the top resource dropdown that the resource appears in. form Configure the appearance of fields in admin forms. field field Declare non-default behavior for a specific attribute. :name ( atom/0 ) - Required. The name of the field to be modified :type - Required. The type of the value in the form. Use default if you are just specifying field order Valid values are :default, :long_text, :short_text, :markdown","ref":"AshAdmin.Resource.html"},{"type":"function","title":"AshAdmin.Resource.actor?/1","doc":"","ref":"AshAdmin.Resource.html#actor?/1"},{"type":"function","title":"AshAdmin.Resource.create_actions/1","doc":"","ref":"AshAdmin.Resource.html#create_actions/1"},{"type":"function","title":"AshAdmin.Resource.destroy_actions/1","doc":"","ref":"AshAdmin.Resource.html#destroy_actions/1"},{"type":"function","title":"AshAdmin.Resource.field/2","doc":"","ref":"AshAdmin.Resource.html#field/2"},{"type":"function","title":"AshAdmin.Resource.fields/1","doc":"","ref":"AshAdmin.Resource.html#fields/1"},{"type":"function","title":"AshAdmin.Resource.format_fields/1","doc":"","ref":"AshAdmin.Resource.html#format_fields/1"},{"type":"function","title":"AshAdmin.Resource.name/1","doc":"","ref":"AshAdmin.Resource.html#name/1"},{"type":"function","title":"AshAdmin.Resource.polymorphic_actions/1","doc":"","ref":"AshAdmin.Resource.html#polymorphic_actions/1"},{"type":"function","title":"AshAdmin.Resource.polymorphic_tables/2","doc":"","ref":"AshAdmin.Resource.html#polymorphic_tables/2"},{"type":"function","title":"AshAdmin.Resource.polymorphic?/2","doc":"","ref":"AshAdmin.Resource.html#polymorphic?/2"},{"type":"function","title":"AshAdmin.Resource.read_actions/1","doc":"","ref":"AshAdmin.Resource.html#read_actions/1"},{"type":"function","title":"AshAdmin.Resource.relationship_display_fields/1","doc":"","ref":"AshAdmin.Resource.html#relationship_display_fields/1"},{"type":"function","title":"AshAdmin.Resource.resource_group/1","doc":"","ref":"AshAdmin.Resource.html#resource_group/1"},{"type":"function","title":"AshAdmin.Resource.show_action/1","doc":"","ref":"AshAdmin.Resource.html#show_action/1"},{"type":"function","title":"AshAdmin.Resource.table_columns/1","doc":"","ref":"AshAdmin.Resource.html#table_columns/1"},{"type":"function","title":"AshAdmin.Resource.update_actions/1","doc":"","ref":"AshAdmin.Resource.html#update_actions/1"},{"type":"module","title":"AshAdmin.Resource.Field","doc":"The representation of a configured field in the admin UI.","ref":"AshAdmin.Resource.Field.html"},{"type":"function","title":"AshAdmin.Resource.Field.schema/0","doc":"","ref":"AshAdmin.Resource.Field.html#schema/0"},{"type":"module","title":"AshAdmin.Resource.Transformers.ValidateTableColumns","doc":"Validates that table columns are all either attributes, or :one cardinality relationships.","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.after_compile?/0","doc":"Callback implementation for Spark.Dsl.Transformer.after_compile?/0 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#after_compile?/0"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.after?/1","doc":"Callback implementation for Spark.Dsl.Transformer.after?/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#after?/1"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.before?/1","doc":"Callback implementation for Spark.Dsl.Transformer.before?/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#before?/1"},{"type":"function","title":"AshAdmin.Resource.Transformers.ValidateTableColumns.transform/1","doc":"Callback implementation for Spark.Dsl.Transformer.transform/1 .","ref":"AshAdmin.Resource.Transformers.ValidateTableColumns.html#transform/1"},{"type":"module","title":"AshAdmin.Router","doc":"Provides LiveView routing for AshAdmin.","ref":"AshAdmin.Router.html"},{"type":"macro","title":"AshAdmin.Router.admin_browser_pipeline/1","doc":"Can be used to create a :browser pipeline easily if you don't have one. By default it is called :browser , but you can rename it by supplying an argument, for example: defmodule MyAppWeb.Router do use Phoenix.Router import AshAdmin.Router admin_browser_pipeline :something scope &quot;/&quot; do pipe_through [ :something ] ash_admin &quot;/admin&quot; end end","ref":"AshAdmin.Router.html#admin_browser_pipeline/1"},{"type":"macro","title":"AshAdmin.Router.ash_admin/2","doc":"Defines an AshAdmin route. It expects the path the admin dashboard will be mounted at and a set of options. Examples defmodule MyAppWeb.Router do use Phoenix.Router scope &quot;/&quot; do import AshAdmin.Router # Make sure you are piping through the browser pipeline # If you don&#39;t have one, see `admin_browser_pipeline/1` pipe_through [ :browser ] ash_admin &quot;/admin&quot; end end","ref":"AshAdmin.Router.html#ash_admin/2"},{"type":"module","title":"Demo.Accounts.Profile","doc":"","ref":"Demo.Accounts.Profile.html"},{"type":"function","title":"Demo.Accounts.Profile.apply_constraints_array/2","doc":"Callback implementation for Ash.Type.apply_constraints_array/2 .","ref":"Demo.Accounts.Profile.html#apply_constraints_array/2"},{"type":"function","title":"Demo.Accounts.Profile.cast_input/2","doc":"Callback implementation for Ash.Type.cast_input/2 .","ref":"Demo.Accounts.Profile.html#cast_input/2"},{"type":"function","title":"Demo.Accounts.Profile.cast_stored/2","doc":"Callback implementation for Ash.Type.cast_stored/2 .","ref":"Demo.Accounts.Profile.html#cast_stored/2"},{"type":"function","title":"Demo.Accounts.Profile.default_short_name/0","doc":"","ref":"Demo.Accounts.Profile.html#default_short_name/0"},{"type":"function","title":"Demo.Accounts.Profile.dump_to_native/2","doc":"Callback implementation for Ash.Type.dump_to_native/2 .","ref":"Demo.Accounts.Profile.html#dump_to_native/2"},{"type":"function","title":"Demo.Accounts.Profile.fetch_key/2","doc":"","ref":"Demo.Accounts.Profile.html#fetch_key/2"},{"type":"function","title":"Demo.Accounts.Profile.handle_change_array/3","doc":"Callback implementation for Ash.Type.handle_change_array/3 .","ref":"Demo.Accounts.Profile.html#handle_change_array/3"},{"type":"function","title":"Demo.Accounts.Profile.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Accounts.Profile.html#input/1"},{"type":"function","title":"Demo.Accounts.Profile.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Accounts.Profile.html#input/2"},{"type":"function","title":"Demo.Accounts.Profile.load/4","doc":"Callback implementation for Ash.Type.load/4 .","ref":"Demo.Accounts.Profile.html#load/4"},{"type":"function","title":"Demo.Accounts.Profile.prepare_change_array/3","doc":"Callback implementation for Ash.Type.prepare_change_array/3 .","ref":"Demo.Accounts.Profile.html#prepare_change_array/3"},{"type":"function","title":"Demo.Accounts.Profile.primary_key_matches?/2","doc":"","ref":"Demo.Accounts.Profile.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Accounts.Profile.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.Profile.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.Profile.spark_is/0","doc":"","ref":"Demo.Accounts.Profile.html#spark_is/0"},{"type":"function","title":"Demo.Accounts.Profile.storage_type/0","doc":"Callback implementation for Ash.Type.storage_type/0 .","ref":"Demo.Accounts.Profile.html#storage_type/0"},{"type":"module","title":"Demo.Accounts.Registry","doc":"","ref":"Demo.Accounts.Registry.html"},{"type":"function","title":"Demo.Accounts.Registry.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.Registry.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.Registry.spark_is/0","doc":"","ref":"Demo.Accounts.Registry.html#spark_is/0"},{"type":"module","title":"Demo.Accounts.User","doc":"","ref":"Demo.Accounts.User.html"},{"type":"function","title":"Demo.Accounts.User.default_short_name/0","doc":"","ref":"Demo.Accounts.User.html#default_short_name/0"},{"type":"function","title":"Demo.Accounts.User.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Accounts.User.html#input/1"},{"type":"function","title":"Demo.Accounts.User.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Accounts.User.html#input/2"},{"type":"function","title":"Demo.Accounts.User.primary_key_matches?/2","doc":"","ref":"Demo.Accounts.User.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Accounts.User.spark_dsl_config/0","doc":"","ref":"Demo.Accounts.User.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Accounts.User.spark_is/0","doc":"","ref":"Demo.Accounts.User.html#spark_is/0"},{"type":"module","title":"Demo.Repo","doc":"","ref":"Demo.Repo.html"},{"type":"function","title":"Demo.Repo.aggregate/3","doc":"Callback implementation for Ecto.Repo.aggregate/3 .","ref":"Demo.Repo.html#aggregate/3"},{"type":"function","title":"Demo.Repo.aggregate/4","doc":"Callback implementation for Ecto.Repo.aggregate/4 .","ref":"Demo.Repo.html#aggregate/4"},{"type":"function","title":"Demo.Repo.all/2","doc":"Callback implementation for Ecto.Repo.all/2 .","ref":"Demo.Repo.html#all/2"},{"type":"function","title":"Demo.Repo.all_tenants/0","doc":"Callback implementation for AshPostgres.Repo.all_tenants/0 .","ref":"Demo.Repo.html#all_tenants/0"},{"type":"function","title":"Demo.Repo.checked_out?/0","doc":"Callback implementation for Ecto.Repo.checked_out?/0 .","ref":"Demo.Repo.html#checked_out?/0"},{"type":"function","title":"Demo.Repo.checkout/2","doc":"Callback implementation for Ecto.Repo.checkout/2 .","ref":"Demo.Repo.html#checkout/2"},{"type":"function","title":"Demo.Repo.child_spec/1","doc":"","ref":"Demo.Repo.html#child_spec/1"},{"type":"function","title":"Demo.Repo.config/0","doc":"Callback implementation for Ecto.Repo.config/0 .","ref":"Demo.Repo.html#config/0"},{"type":"function","title":"Demo.Repo.default_options/1","doc":"Callback implementation for Ecto.Repo.default_options/1 .","ref":"Demo.Repo.html#default_options/1"},{"type":"function","title":"Demo.Repo.default_prefix/0","doc":"Callback implementation for AshPostgres.Repo.default_prefix/0 .","ref":"Demo.Repo.html#default_prefix/0"},{"type":"function","title":"Demo.Repo.delete!/2","doc":"Callback implementation for Ecto.Repo.delete!/2 .","ref":"Demo.Repo.html#delete!/2"},{"type":"function","title":"Demo.Repo.delete/2","doc":"Callback implementation for Ecto.Repo.delete/2 .","ref":"Demo.Repo.html#delete/2"},{"type":"function","title":"Demo.Repo.delete_all/2","doc":"Callback implementation for Ecto.Repo.delete_all/2 .","ref":"Demo.Repo.html#delete_all/2"},{"type":"function","title":"Demo.Repo.disconnect_all/2","doc":"A convenience function for SQL-based repositories that forces all connections in the pool to disconnect within the given interval. See Ecto.Adapters.SQL.disconnect_all/3 for more information.","ref":"Demo.Repo.html#disconnect_all/2"},{"type":"function","title":"Demo.Repo.exists?/2","doc":"Callback implementation for Ecto.Repo.exists?/2 .","ref":"Demo.Repo.html#exists?/2"},{"type":"function","title":"Demo.Repo.explain/3","doc":"A convenience function for SQL-based repositories that executes an EXPLAIN statement or similar depending on the adapter to obtain statistics for the given query. See Ecto.Adapters.SQL.explain/4 for more information.","ref":"Demo.Repo.html#explain/3"},{"type":"function","title":"Demo.Repo.from_ecto/1","doc":"","ref":"Demo.Repo.html#from_ecto/1"},{"type":"function","title":"Demo.Repo.get!/3","doc":"Callback implementation for Ecto.Repo.get!/3 .","ref":"Demo.Repo.html#get!/3"},{"type":"function","title":"Demo.Repo.get/3","doc":"Callback implementation for Ecto.Repo.get/3 .","ref":"Demo.Repo.html#get/3"},{"type":"function","title":"Demo.Repo.get_by!/3","doc":"Callback implementation for Ecto.Repo.get_by!/3 .","ref":"Demo.Repo.html#get_by!/3"},{"type":"function","title":"Demo.Repo.get_by/3","doc":"Callback implementation for Ecto.Repo.get_by/3 .","ref":"Demo.Repo.html#get_by/3"},{"type":"function","title":"Demo.Repo.get_dynamic_repo/0","doc":"Callback implementation for Ecto.Repo.get_dynamic_repo/0 .","ref":"Demo.Repo.html#get_dynamic_repo/0"},{"type":"function","title":"Demo.Repo.in_transaction?/0","doc":"Callback implementation for Ecto.Repo.in_transaction?/0 .","ref":"Demo.Repo.html#in_transaction?/0"},{"type":"function","title":"Demo.Repo.init/2","doc":"Callback implementation for Ecto.Repo.init/2 .","ref":"Demo.Repo.html#init/2"},{"type":"function","title":"Demo.Repo.insert!/2","doc":"Callback implementation for Ecto.Repo.insert!/2 .","ref":"Demo.Repo.html#insert!/2"},{"type":"function","title":"Demo.Repo.insert/2","doc":"Callback implementation for Ecto.Repo.insert/2 .","ref":"Demo.Repo.html#insert/2"},{"type":"function","title":"Demo.Repo.insert_all/3","doc":"Callback implementation for Ecto.Repo.insert_all/3 .","ref":"Demo.Repo.html#insert_all/3"},{"type":"function","title":"Demo.Repo.insert_or_update!/2","doc":"Callback implementation for Ecto.Repo.insert_or_update!/2 .","ref":"Demo.Repo.html#insert_or_update!/2"},{"type":"function","title":"Demo.Repo.insert_or_update/2","doc":"Callback implementation for Ecto.Repo.insert_or_update/2 .","ref":"Demo.Repo.html#insert_or_update/2"},{"type":"function","title":"Demo.Repo.installed_extensions/0","doc":"Callback implementation for AshPostgres.Repo.installed_extensions/0 .","ref":"Demo.Repo.html#installed_extensions/0"},{"type":"function","title":"Demo.Repo.load/2","doc":"Callback implementation for Ecto.Repo.load/2 .","ref":"Demo.Repo.html#load/2"},{"type":"function","title":"Demo.Repo.migrations_path/0","doc":"Callback implementation for AshPostgres.Repo.migrations_path/0 .","ref":"Demo.Repo.html#migrations_path/0"},{"type":"function","title":"Demo.Repo.min_pg_version/0","doc":"Callback implementation for AshPostgres.Repo.min_pg_version/0 .","ref":"Demo.Repo.html#min_pg_version/0"},{"type":"function","title":"Demo.Repo.on_transaction_begin/1","doc":"Callback implementation for AshPostgres.Repo.on_transaction_begin/1 .","ref":"Demo.Repo.html#on_transaction_begin/1"},{"type":"function","title":"Demo.Repo.one!/2","doc":"Callback implementation for Ecto.Repo.one!/2 .","ref":"Demo.Repo.html#one!/2"},{"type":"function","title":"Demo.Repo.one/2","doc":"Callback implementation for Ecto.Repo.one/2 .","ref":"Demo.Repo.html#one/2"},{"type":"function","title":"Demo.Repo.override_migration_type/1","doc":"Callback implementation for AshPostgres.Repo.override_migration_type/1 .","ref":"Demo.Repo.html#override_migration_type/1"},{"type":"function","title":"Demo.Repo.preload/3","doc":"Callback implementation for Ecto.Repo.preload/3 .","ref":"Demo.Repo.html#preload/3"},{"type":"function","title":"Demo.Repo.prepare_query/3","doc":"Callback implementation for Ecto.Repo.prepare_query/3 .","ref":"Demo.Repo.html#prepare_query/3"},{"type":"function","title":"Demo.Repo.put_dynamic_repo/1","doc":"Callback implementation for Ecto.Repo.put_dynamic_repo/1 .","ref":"Demo.Repo.html#put_dynamic_repo/1"},{"type":"function","title":"Demo.Repo.query!/3","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information.","ref":"Demo.Repo.html#query!/3"},{"type":"function","title":"Demo.Repo.query/3","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information.","ref":"Demo.Repo.html#query/3"},{"type":"function","title":"Demo.Repo.query_many!/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many!/4 for more information.","ref":"Demo.Repo.html#query_many!/3"},{"type":"function","title":"Demo.Repo.query_many/3","doc":"A convenience function for SQL-based repositories that executes the given multi-result query. See Ecto.Adapters.SQL.query_many/4 for more information.","ref":"Demo.Repo.html#query_many/3"},{"type":"function","title":"Demo.Repo.reload!/2","doc":"Callback implementation for Ecto.Repo.reload!/2 .","ref":"Demo.Repo.html#reload!/2"},{"type":"function","title":"Demo.Repo.reload/2","doc":"Callback implementation for Ecto.Repo.reload/2 .","ref":"Demo.Repo.html#reload/2"},{"type":"function","title":"Demo.Repo.rollback/1","doc":"Callback implementation for Ecto.Repo.rollback/1 .","ref":"Demo.Repo.html#rollback/1"},{"type":"function","title":"Demo.Repo.start_link/1","doc":"Callback implementation for Ecto.Repo.start_link/1 .","ref":"Demo.Repo.html#start_link/1"},{"type":"function","title":"Demo.Repo.stop/1","doc":"Callback implementation for Ecto.Repo.stop/1 .","ref":"Demo.Repo.html#stop/1"},{"type":"function","title":"Demo.Repo.stream/2","doc":"Callback implementation for Ecto.Repo.stream/2 .","ref":"Demo.Repo.html#stream/2"},{"type":"function","title":"Demo.Repo.tenant_migrations_path/0","doc":"Callback implementation for AshPostgres.Repo.tenant_migrations_path/0 .","ref":"Demo.Repo.html#tenant_migrations_path/0"},{"type":"function","title":"Demo.Repo.to_ecto/1","doc":"","ref":"Demo.Repo.html#to_ecto/1"},{"type":"function","title":"Demo.Repo.to_sql/2","doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information.","ref":"Demo.Repo.html#to_sql/2"},{"type":"function","title":"Demo.Repo.transaction/2","doc":"Callback implementation for Ecto.Repo.transaction/2 .","ref":"Demo.Repo.html#transaction/2"},{"type":"function","title":"Demo.Repo.update!/2","doc":"Callback implementation for Ecto.Repo.update!/2 .","ref":"Demo.Repo.html#update!/2"},{"type":"function","title":"Demo.Repo.update/2","doc":"Callback implementation for Ecto.Repo.update/2 .","ref":"Demo.Repo.html#update/2"},{"type":"function","title":"Demo.Repo.update_all/3","doc":"Callback implementation for Ecto.Repo.update_all/3 .","ref":"Demo.Repo.html#update_all/3"},{"type":"module","title":"Demo.Tickets.Comment","doc":"","ref":"Demo.Tickets.Comment.html"},{"type":"function","title":"Demo.Tickets.Comment.default_short_name/0","doc":"","ref":"Demo.Tickets.Comment.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Comment.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Comment.html#input/1"},{"type":"function","title":"Demo.Tickets.Comment.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Comment.html#input/2"},{"type":"function","title":"Demo.Tickets.Comment.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Comment.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Comment.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Comment.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Comment.spark_is/0","doc":"","ref":"Demo.Tickets.Comment.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Customer","doc":"","ref":"Demo.Tickets.Customer.html"},{"type":"function","title":"Demo.Tickets.Customer.default_short_name/0","doc":"","ref":"Demo.Tickets.Customer.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Customer.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Customer.html#input/1"},{"type":"function","title":"Demo.Tickets.Customer.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Customer.html#input/2"},{"type":"function","title":"Demo.Tickets.Customer.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Customer.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Customer.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Customer.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Customer.spark_is/0","doc":"","ref":"Demo.Tickets.Customer.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Organization","doc":"","ref":"Demo.Tickets.Organization.html"},{"type":"function","title":"Demo.Tickets.Organization.default_short_name/0","doc":"","ref":"Demo.Tickets.Organization.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Organization.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Organization.html#input/1"},{"type":"function","title":"Demo.Tickets.Organization.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Organization.html#input/2"},{"type":"function","title":"Demo.Tickets.Organization.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Organization.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Organization.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Organization.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Organization.spark_is/0","doc":"","ref":"Demo.Tickets.Organization.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Registry","doc":"","ref":"Demo.Tickets.Registry.html"},{"type":"function","title":"Demo.Tickets.Registry.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Registry.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Registry.spark_is/0","doc":"","ref":"Demo.Tickets.Registry.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Representative","doc":"","ref":"Demo.Tickets.Representative.html"},{"type":"function","title":"Demo.Tickets.Representative.default_short_name/0","doc":"","ref":"Demo.Tickets.Representative.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Representative.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Representative.html#input/1"},{"type":"function","title":"Demo.Tickets.Representative.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Representative.html#input/2"},{"type":"function","title":"Demo.Tickets.Representative.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Representative.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Representative.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Representative.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Representative.spark_is/0","doc":"","ref":"Demo.Tickets.Representative.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.Ticket","doc":"","ref":"Demo.Tickets.Ticket.html"},{"type":"function","title":"Demo.Tickets.Ticket.default_short_name/0","doc":"","ref":"Demo.Tickets.Ticket.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.Ticket.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.Ticket.html#input/1"},{"type":"function","title":"Demo.Tickets.Ticket.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.Ticket.html#input/2"},{"type":"function","title":"Demo.Tickets.Ticket.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.Ticket.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.Ticket.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.Ticket.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.Ticket.spark_is/0","doc":"","ref":"Demo.Tickets.Ticket.html#spark_is/0"},{"type":"module","title":"Demo.Tickets.TicketLink","doc":"","ref":"Demo.Tickets.TicketLink.html"},{"type":"function","title":"Demo.Tickets.TicketLink.default_short_name/0","doc":"","ref":"Demo.Tickets.TicketLink.html#default_short_name/0"},{"type":"function","title":"Demo.Tickets.TicketLink.input/1","doc":"Validates that the keys in the provided input are valid for at least one action on the resource. Raises a KeyError error at compile time if not. This exists because generally a struct should only ever be created by Ash as a result of a successful action. You should not be creating records manually in code, e.g %MyResource{value: 1, value: 2} . Generally that is fine, but often with embedded resources it is nice to be able to validate the keys that are being provided, e.g Resource |&gt; Ash.Changeset . for_create ( :create , %{ embedded : EmbeddedResource . input ( foo : 1 , bar : 2 ) } ) |&gt; MyApp.Api . create ( )","ref":"Demo.Tickets.TicketLink.html#input/1"},{"type":"function","title":"Demo.Tickets.TicketLink.input/2","doc":"Same as input/1 , except restricts the keys to values accepted by the action provided.","ref":"Demo.Tickets.TicketLink.html#input/2"},{"type":"function","title":"Demo.Tickets.TicketLink.primary_key_matches?/2","doc":"","ref":"Demo.Tickets.TicketLink.html#primary_key_matches?/2"},{"type":"function","title":"Demo.Tickets.TicketLink.spark_dsl_config/0","doc":"","ref":"Demo.Tickets.TicketLink.html#spark_dsl_config/0"},{"type":"function","title":"Demo.Tickets.TicketLink.spark_is/0","doc":"","ref":"Demo.Tickets.TicketLink.html#spark_is/0"},{"type":"extras","title":"AshAdmin","doc":"An admin UI for Ash resources. Built with Phoenix LiveView.","ref":"readme.html"},{"type":"extras","title":"AshAdmin - Demo","doc":"https://www.youtube.com/watch?v=aFMLz3cpQ8c","ref":"readme.html#demo"},{"type":"extras","title":"AshAdmin - Usage","doc":"First, ensure you've added ash_admin to your mix.exs file. { :ash_admin , &quot;~&gt; 0.9.0&quot; }","ref":"readme.html#usage"},{"type":"extras","title":"AshAdmin - Setup","doc":"Ensure your apis are configured in config.exs config :my_app , ash_apis : [ MyApp.Foo , MyApp.Bar ] Add the admin extension to each api you want to show in the admin dashboard, and configure it to show use Ash.Api , extensions : [ AshAdmin.Api ] admin do show? true end Modify your router to add ash admin at whatever path you'd like to serve it at. defmodule MyAppWeb.Router do use Phoenix.Router import AshAdmin.Router # AshAdmin requires a Phoenix LiveView `:browser` pipeline # If you DO NOT have a `:browser` pipeline already, then AshAdmin has a `:browser` pipeline # Most applications will not need this: admin_browser_pipeline :browser scope &quot;/&quot; do # Pipe it through your browser pipeline pipe_through [ :browser ] ash_admin &quot;/admin&quot; end end Now start your project (usually by running mix phx.server in a terminal) and visit /admin in your browser (or whatever path you gave to ash_admin in your router). Content Security Policy If your app specifies a content security policy header, eg. via plug :put_secure_browser_headers , %{ &quot;content-security-policy&quot; =&gt; &quot;default-src &#39;self&#39;&quot; } in your router, then all of the styles and JavaScript used to power AshAdmin will be blocked by your browser. To avoid this, you can add the specific AshAdmin nonces to the default-src allowlist, ie. plug :put_secure_browser_headers , %{ &quot;content-security-policy&quot; =&gt; &quot;default-src &#39;nonce-ash_admin-Ed55GFnX&#39; &#39;self&#39;&quot; } This will allow AshAdmin-generated inline CSS and JS blocks to execute normally.","ref":"readme.html#setup"},{"type":"extras","title":"AshAdmin - Configuration","doc":"See the documentation in AshAdmin.Resource and AshAdmin.Api for information on the available configuration.","ref":"readme.html#configuration"},{"type":"extras","title":"AshAdmin - Development","doc":"To work on ash_admin, you'll want to be able to run the dev app. You'll need to have postgres setup locally, at which point you can do the following: mix ash_postgres.create mix migrate mix migrate_tenants Then, you can start the app with: mix dev If you make changes to the resources, you can generate migrations with mix generate_migrations","ref":"readme.html#development"},{"type":"extras","title":"AshAdmin - Contributors","doc":"Ash is made possible by its excellent community! Become a contributor","ref":"readme.html#contributors"}]